SystemOrganization addCategory: #'MC2-Meta-Repository-Directory'!

MDRepositoryElement subclass: #MDDirectoryRepositoryElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Repository-Directory'!

!MDDirectoryRepositoryElement methodsFor: 'adapting' stamp: 'cwp 10/16/2009 16:25'!
adaptedFor: aDomain
	^ aDomain adaptorForDirectoryRepositoryElement: self! !

!MDDirectoryRepositoryElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:32'!
handleWith: anObject
	^ anObject handleDirectoryRepository: self! !

MDRepositoryAdaptor subclass: #MDDirectoryRepositoryAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Meta-Repository-Directory'!

!MDDirectoryRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/18/2009 21:49'!
createRepository: properties
	^ (MDDirectoryRepository id: element id)
		name: properties name;
		primaryName: properties primaryName;
		yourself! !

!MDDirectoryRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/18/2009 23:01'!
isUpToDate: properties
	| repository |
	repository := self repositoryIfAbsent: [^ false].
	^ repository name = properties name! !

!MDDirectoryRepositoryAdaptor methodsFor: 'as yet unclassified' stamp: 'cwp 10/21/2009 23:50'!
modify: aRepository with: properties
	(aRepository updateName: properties name) | (aRepository updatePrimaryName: properties primaryName)
		ifTrue: [aRepository initFiles]
	! !

!MDDirectoryRepositoryAdaptor methodsFor: 'public' stamp: 'cwp 10/21/2009 16:10'!
update: properties 
	| repository |
	repository := self repositoryIfAbsent: [ ^ properties ].
	properties name: repository name.
	properties primaryName: repository primaryName.
	^ properties! !
